// $Id: tsplib.cc,v 1.4 2008/11/25 22:56:06 xulin730 Exp $

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <math.h>
#include <iostream>
#include <fstream>
#include "tsplib.h"
#include <queue>
#include <vector>
#include <limits>

const double dMax = std::numeric_limits<double>::max();

///////////////////////////////////////////////////////////////////////////
// transfer a string to an integer
int str_to_i(string newstr){
 int myvalue  ;
 istringstream in(newstr);
 in >> myvalue;
 return myvalue;
}

/////////////////////////////////////////////////////////////////////////////
// transfer a string to double
double str_to_f(string newstr){
 double myvalue ; 
 istringstream in(newstr);
 in >> myvalue;
 return myvalue;
}

/////////////////////////////////////////////////////////////////////////////
// compare two pair (not used in my code)
int pair_comp (pair <int, int> p1, pair <int, int> p2)
{
     int result=0;
     if ((p1.first == p2.first) && (p1.second == p2.second))
     result=1;
return result;
}; 

/////////////////////////////////////////////////////////////////////////////
// part of read TSP instance. SHOULD not be changed
void TSPinstance::get_key_value_pair ( char *inputline, char *key, char *value )
{
    int cur, c2;
    cur = 0;    
    // skip line leading whitespaces
    while ( ( ( inputline[ cur ] == ' ' ) || ( inputline[ cur ] == ':' ) )
            && ( inputline[ cur ] != 0 ) )
        cur++;
    // read key
    c2 = 0;
    while ( ( inputline[ cur ] != ' ' ) && ( inputline[ cur ] != ':' )
            && ( inputline[ cur ] != 0 ) ){
        key[ c2 ] = inputline[ cur ];
        cur++;
        c2++;
     
    }
    key[ c2 ] = 0;
    // skip whitespaces between key and value
    while ( ( ( inputline[ cur ] == ' ' ) || ( inputline[ cur ] == ':' ) )
            && ( inputline[ cur ] != 0 ) )
        cur++;
    // read value
    c2 = 0;
    while ( ( inputline[ cur ] != 0 ) &&  ( inputline[ cur ] != '\n' )&&  ( inputline[ cur ] != '\r' )){
       
        value[ c2 ] = inputline[ cur ];
       
        c2++;       
        
        cur++;
    }
       value[ c2] = 0;
     
//   value[ c2-1 ] = 0;
//    value[c2+1]=0;
}

//////////////////////////////////////////////////////////////////////////////
void TSPinstance::get_key_value_pair (string inputline, string& key, string& value )
{
     string myvalue ; 
     istringstream in(inputline);
     in >> myvalue;
     int isTrue=myvalue.find(":");
     if (isTrue>-1){
        key=myvalue.erase(myvalue.size()-1,1);
        in >> value;
        }
     else{
          key=myvalue;
          in >> myvalue >> value;
          }
}

/////////////////////////////////////////////////////////////////////////////
// read TSP instance should NOT be changed
int TSPinstance::parse_data_NODE_COORD_SECTION (ifstream &input)
{
    struct mynode_coord_section *dsect;
    int i;
    // set tsplibfile's node coord type, if not set correctly in file
    if ( (spec->node_coord_type == TSPLIB_INVALID )
            || ( spec->node_coord_type == TSPLIB_NO_COORDS ) ){
        //fprintf (stderr,
        //       "Warning: NODE_COORD_TYPE not specified or set to NO_COORDS, ");
       spec->node_coord_type = TSPLIB_TWOD_COORDS;
    }
    // alloc memory
    dsect = ( struct mynode_coord_section * ) calloc ( 1, sizeof ( struct mynode_coord_section ) );
    dsect->index = ( int * ) calloc ( spec->dimension, sizeof ( int ) );
    dsect->cx = ( double * ) calloc ( spec->dimension, sizeof ( double ) );
    dsect->cy = ( double * ) calloc ( spec->dimension, sizeof ( double ) );
    if (spec->node_coord_type == TSPLIB_THREED_COORDS )
        dsect->cz = ( double * ) calloc ( spec->dimension, sizeof ( double ) );
    // read data lines
    for ( i = 0; i < spec->dimension; i++ ){
        // different cases for two or three dimensions
        if (spec->node_coord_type == TSPLIB_THREED_COORDS ){
            input >> dsect->index[ i ];                  
            input >> dsect->cx[ i ];
            input >> dsect->cy[ i ];
            input >> dsect->cz[ i ];
        }
        else{
            input >> dsect->index[ i ];
            input >> dsect->cx[ i ];
            input >> dsect->cy[ i ];
        }
    }
    // set section into tsplibfile struct
    node_coord_section = dsect;
    return TSPLIB_OK;
}

/////////////////////////////////////////////////////////////////////////////
// READ TSP instance should not be changed
int TSPinstance::parse_key_value_pair (char *key, char *value )
{
    int i, result;
    result = TSPLIB_OK;
    // if current line has a NAME key, store value in tsplibfile struct
    if (strcasecmp ( key, "NAME" ) == 0 ){
    //  spec.name = new char[512];   
        spec->name.assign( value );     
    }
    // if current line has a TYPE key, parse and store value in tsplibfile struct
    if ( strcasecmp ( key, "TYPE" ) == 0 ){
        spec->type = TSPLIB_INVALID;
        // check string if it represents a known type
        for ( i = 0; i < tsplib_type_cnt; i++ )
            if ( strncasecmp
                    ( value, tsplib_type_str[ i ], strlen ( tsplib_type_str[ i ] ) ) == 0 )
                spec->type = i;
        // if found type is unknown or not supported...
        if ( ( spec->type != TSPLIB_TYPE_TSP )&& ( spec->type != TSPLIB_TYPE_TOUR ) ){
            fprintf ( stderr, "Error: TYPE not specified or not supported. Only TSP and TOUR are supported.\n" );
            result = TSPLIB_ERROR_NOT_SUPPORTED_VALUE;
        }
    }

    // if current line has a COMMENT key, store value in tsplibfile struct
    if ( strcasecmp ( key, "COMMENT" ) == 0 ){
        spec->comment =( char * ) calloc ( strlen ( value ) + 1, sizeof ( char ) );
        spec->comment.assign( value );
    }
    // if current line has a EDGE_WEIGHT_TYPE key, parse and store value in tsplibfile struct
    if ( strcasecmp ( key, "EDGE_WEIGHT_TYPE" ) == 0 ){
        spec->edge_weight_type = TSPLIB_INVALID;   
          // check string if it represents a known type
        for ( i = 0; i < tsplib_edge_weight_type_cnt; i++ ){    
            if ( strcmp (value, tsplib_edge_weight_type_str[ i ] ) == 0 )
                spec->edge_weight_type = i;
                }
        // if found type is unknown or not supported...
        if ( spec->edge_weight_type == TSPLIB_EXPICIT ){
            fprintf ( stderr, "Error: EDGE_WEIGHT_TYPE = EXPLICIT not supported. Only EUC_2D and EUC_3D are supported.\n" );
            result = TSPLIB_ERROR_NOT_SUPPORTED_VALUE;
        }
    }

    // if current line has a NODE_COORD_TYPE key, parse and store value in tsplibfile struct
    if ( strcmp ( key, "NODE_COORD_TYPE" ) == 0 ){
        spec->node_coord_type = TSPLIB_INVALID;
        // check string if it represents a known type
        for ( i = 0; i < tsplib_node_coord_type_cnt; i++ )
            if ( strcmp ( value, tsplib_node_coord_type_str[ i ] ) == 0 )
                spec->node_coord_type = i;
    }

    // if current line has a DIMENSION key, store value in tsplibfile struct
    if ( strcasecmp ( key, "DIMENSION" ) == 0 )
        spec->dimension = atoi ( value );
    return result;
}

/////////////////////////////////////////////////////////////////////////////
TSPinstance::TSPinstance(char* tspfilename)
{
    char *buffer, *key, *value;
    int result;
    indexCount=0;
      
    spec =new specification;
    node_coord_section=new mynode_coord_section;
//    struct tsplibfile *tsplibfile_;
 ifstream infile(tspfilename);
  if (!infile) {
    fprintf(stderr, "c Error: could not read from %s.\n", tspfilename);
    exit(1);
  }
    // alloc and initialize memory
    result = TSPLIB_OK;
    buffer = ( char * ) calloc ( BUFFER_SIZE, sizeof ( char ) );
    key = ( char * ) calloc ( BUFFER_SIZE, sizeof ( char ) );
    value = ( char * ) calloc ( BUFFER_SIZE, sizeof ( char ) );
    // read every input line
    infile.getline(buffer, BUFFER_SIZE, '\n'); 
    while ( infile && ( result == TSPLIB_OK ) ){         
// extract key and value pairs
        get_key_value_pair (buffer, key, value );        
//        cout << key << ": "<< value <<endl;
        // parse key and value pairs
        if ( key[ 0 ] != 0 )
            result = parse_key_value_pair (key, value );     
        // if current line starts a node coord section, parse section       
        if ( ( result == TSPLIB_OK ) && ( strncasecmp ( buffer, "NODE_COORD_SECTION", 17) == 0 ) )
           result = parse_data_NODE_COORD_SECTION (infile);
        infile.getline(buffer, BUFFER_SIZE, '\n');       
    }
    // free memory
    free ( buffer );
    free ( key );
    free ( value );
}

/////////////////////////////////////////////////////////////////////////////
TSPinstance::~TSPinstance ()
{
     if (spec != NULL ){
            if ( !spec->name.empty() )
            	 spec->name.clear();
                //free ( tsplibfile->spec->name );
            if ( !spec->comment.empty() )
                spec->comment.clear();
            if ( !spec->edge_weight_format.empty())
                 spec->edge_weight_format.clear() ;
            if (!spec->edge_data_format.empty() )
                spec->edge_data_format.clear();
            if ( !spec->display_data_type.empty() )
                spec->display_data_type.clear();
            free ( spec );
        } 
     if ( node_coord_section != NULL ){
        if ( node_coord_section->index != NULL )
           free ( node_coord_section->index );
        if ( node_coord_section->cx != NULL )
           free ( node_coord_section->cx );
        if (node_coord_section->cy != NULL )
           free (node_coord_section->cy );
        if ( node_coord_section->cz != NULL )
           free (node_coord_section->cz );
        free (node_coord_section );
            }   

/*             
     free(mst_visited);
     free(mst_d); 
     free(mst_parent); 
 //     cout<<"something wrong"<<endl;
     for (int i=0; i<spec->dimension; i++){
         free (mst_tree[i]);
     }
*/
//      cout<<"something wrong"<<endl;
 //    delete(lpedgefreq);
  
 //    delete(strseed);
  //   delete(finalfile);
   //  delete(lptour);
  //       cout<<"something wrong"<<endl;
  //   delete(tourfile);
  //    cout<<"something wrong"<<endl;
       
    
     
  //  LSsolver->~BinSolver();
  //  BCsolver->~BinSolver();  
    }
    
/////////////////////////////////////////////////////////////////////////
void TSPinstance::BuildLS(char* tourfile, char* finalfile, char* strseed)
{
  // --vallst
  LSsolver=new BinSolver ("linkern", 10, 9);

  
  LSsolver->argv[1] = const_cast< char* >("-R");
  LSsolver->argv[2] = const_cast< char* >("100");
  LSsolver->argv[3] = const_cast< char* >("-S");
  LSsolver->argv[4] = tourfile;
  LSsolver->argv[5] = const_cast< char* >("-s");
  LSsolver->argv[6] = strseed;
  LSsolver->argv[7] = const_cast< char* >("-o");
  LSsolver->argv[8] = finalfile;
  LSsolver->argv[10] = NULL;
}
 
void TSPinstance::BuildBC(char* lptour, char* strseed)
{
  BCsolver=new BinSolver ("concorde", 9, 8);
 
  BCsolver->argv[1] = const_cast< char* >("-B");
//  BCsolver->argv[2] = const_cast< char* >("-V");
  BCsolver->argv[2] = const_cast< char* >("-I");
  BCsolver->argv[3] = const_cast< char* >("-s");
//  binSolvers[1]->argv[4] = strseed;
   BCsolver->argv[4] = const_cast< char* >("123456");
  BCsolver->argv[5] = const_cast< char* >("-x");
  BCsolver->argv[6] = const_cast< char* >("-X");
  BCsolver->argv[7] = lptour;
  BCsolver->argv[9] = NULL;
}

/////////////////////////////////////////////////////////////////////////////
void TSPinstance::outputSpec(){
     cout << "Instance name: "  << spec->name << endl;
      cout << "Dimension: "  << spec->dimension << endl;
      cout << "Edge_weight_type: "  << spec->edge_weight_type << endl;
      
     
     }
     
/////////////////////////////////////////////////////////////////////////////     
void TSPinstance::comp_std () {
     double tmpcost;
     double tmpPowSum=0;
     double tmpSum=0;
     double tmpPow3Sum=0;
     double totaledge = spec->dimension*(spec->dimension-1)/2;
     for (int i=0; i<spec->dimension; i++ ){
     for (int j=i+1; j<spec->dimension; j++){
         double tmpx1= node_coord_section->cx[i];
         double tmpx2= node_coord_section->cx[j];
         double tmpy1= node_coord_section->cy[i];
         double tmpy2= node_coord_section->cy[j];
         tmpcost=comp_dist(i, j);       
         tmpPowSum= tmpPowSum+tmpcost*tmpcost;
         tmpSum=tmpSum+tmpcost;
         tmpPow3Sum=tmpPow3Sum + pow(tmpcost, 3);
     }
     }
     cost_avg= tmpSum/totaledge;
     cost_std = sqrt((tmpPowSum-pow(tmpSum, 2)/totaledge)/totaledge);
     cost_skew = tmpPow3Sum - 3*tmpPowSum*cost_avg+3*tmpSum*pow(cost_avg, 2)-totaledge*pow(cost_avg,3);
if (cost_skew!=0)
     cost_skew = (totaledge*pow(cost_std,3))/cost_skew;
  //   cost_skew = sqrt(totaledge*(totaledge-1))*cost_skew/(totaledge-2);
     writeFeature("num_nodes", spec->dimension);
     writeFeature("cost_matrix_avg",cost_avg);
     writeFeature("cost_matrix_std",cost_std/cost_avg);
     writeFeature("cost_matrix_skew",cost_skew);
     }

/////////////////////////////////////////////////////////////////////////////
double TSPinstance::comp_dist(int i, int j)
{
    
        double tmpx1= node_coord_section->cx[i];
         double tmpx2= node_coord_section->cx[j];
         double tmpy1= node_coord_section->cy[i];
         double tmpy2= node_coord_section->cy[j];
            
         return sqrt(pow((tmpx1-tmpx2),2)+pow((tmpy1-tmpy2),2));
 }

/////////////////////////////////////////////////////////////////////////////
void TSPinstance::comp_ass(int num, vector<double> myv, double normterm, double& avg, double& std, double& skew)
{
 
   double tmpPowSum=0.0;
   double tmpSum=0.0;
   double tmpPow3Sum=0.0;
   double tmpfoo;
   avg=0.0;
   std=0.0;
   skew=0.0;
   for (int i=0; i< num; i++){   
        double foo=myv.at(i)/normterm; 
         tmpPowSum= tmpPowSum+foo*foo;
         tmpSum=tmpSum+foo;
         tmpPow3Sum=tmpPow3Sum +foo*foo*foo;
    }
   
   
    avg=tmpSum/num;
    tmpfoo=(tmpPowSum-pow(tmpSum, 2)/num)/num;
    if ((tmpfoo> avg* -1e-10) && (tmpfoo<0))
        tmpfoo=0;

    std=sqrt(tmpfoo);
    skew=tmpPow3Sum - 3*tmpPowSum*avg+3*tmpSum*pow(avg, 2)-num*pow(avg,3);
if (skew!=0)
    skew=(num*pow(std,3))/skew;
}

/////////////////////////////////////////////////////////////////////////////
void TSPinstance::comp_ass(int num, double* myarray, double normterm, double& avg, double& std, double& skew)
{
 
   double tmpPowSum=0.0;
   double tmpSum=0.0;
   double tmpPow3Sum=0.0;
   double tmpfoo;
   avg=0.0;
   std=0.0;
   skew=0.0;
   for (int i=0; i< num; i++){   
        double foo=myarray[i]/normterm; 
         tmpPowSum= tmpPowSum+foo*foo;
         tmpSum=tmpSum+foo;
         tmpPow3Sum=tmpPow3Sum +foo*foo*foo;
    }   
    avg=tmpSum/num;
    tmpfoo=(tmpPowSum-pow(tmpSum, 2)/num)/num;
    if ((tmpfoo> avg* -1e-10) && (tmpfoo<0))
        tmpfoo=0;
    std=sqrt(tmpfoo);

    skew=tmpPow3Sum - 3*tmpPowSum*avg+3*tmpSum*pow(avg, 2)-num*pow(avg,3);
if (skew!=0)
    skew=(num*pow(std,3))/skew;
}



vector<double> TSPinstance::comp_q(vector<double> myv)
{
  vector<double> results;
  int mysize;
   sort(myv.begin(), myv.end());
   mysize=myv.size();
   results.push_back(myv[0]);
   results.push_back(myv[mysize/4]);
   results.push_back(myv[mysize/2]);
   results.push_back(myv[mysize*3/4]);
   results.push_back(myv[mysize-1]);
   
   return results;
 
}

void TSPinstance::comp_mst()
{
	int i, j, k, u, v;
	double minfoo;
	int src=0;
	mst_visited = ( int * ) calloc ( spec->dimension, sizeof ( int ) );
	mst_d = ( double * ) calloc ( spec->dimension, sizeof ( double ) );
	mst_parent = ( int * ) calloc ( spec->dimension, sizeof ( int ) );
    mst_tree = new int* [spec->dimension]; 
    double *mst_length;
    mst_length= new double [spec->dimension-1];
    int counter=0;          // Allocate the rows.
  double avg, std, skew;
    for(i = 0; i < spec->dimension; i++)
      mst_tree[i] = new int [2];
     
	for (i = 0; i < spec->dimension; i++){
		mst_d[i] =comp_dist(src, i);
		mst_visited[i] = 0;
		mst_parent[i] = src;
	}
	mst_visited[src] = 1;
	mst_cost = 0;
	k = 0;
	//cout<< "for 1" <<endl;
	for (i = 0; i < spec->dimension-1; i++){
		minfoo = dMax;
		//cout<< "for 2" <<endl;
		for (j = 0; j < spec->dimension; j++){
           // cout<< "for 3  " << j<<endl;
			if (!mst_visited[j] && mst_d[j] < minfoo){
				minfoo = mst_d[j];
				u = j;
			}
		}
//	        cout<< "from " <<src << " to " << u<<  " dist is "<< mst_d[u]<<endl;
		mst_visited[u] = 1;
		mst_cost = mst_cost + mst_d[u];
                mst_length[counter]=mst_d[u];
                counter++;
		mst_tree[k][0] = mst_parent[u];
		mst_tree[k++][1] = u;
		//cout<< "wait k" << k<<endl;
		for (v = 0; v < spec->dimension; v++){
           //    cout<< "for 4" <<endl;
			if (!mst_visited[v] && (comp_dist(u, v) < mst_d[v])){
				mst_d[v] = comp_dist(u, v);
				mst_parent[v] = u;
			}
	}
}
   writeFeature("mst_length",mst_cost/(cost_avg*spec->dimension));
    comp_ass(spec->dimension-1, mst_length, cost_avg, avg, std, skew); 
    writeFeature("mst_length_avg", avg);
   if (avg!=0)
      writeFeature("mst_length_std", std/avg);
   else
      writeFeature("mst_length_std", 0);
    writeFeature("mst_length_skew", skew);

	 // computer the node degress of  mst
	 delete [] mst_length;
    double *mst_degree;
    mst_degree= new double [spec->dimension];
    int foo1, foo2;
  
    
   	for (i = 0; i < spec->dimension; i++) {
	   mst_degree[i]=0.0;
    }
    
   	for (i = 0; i < spec->dimension-1; i++) {
		foo1=mst_tree[i][0];
        foo2=mst_tree[i][1];
        mst_degree[foo1]++;
        mst_degree[foo2]++;
    }
    
    comp_ass(spec->dimension, mst_degree, 1, avg, std, skew ); 
    writeFeature("mst_degree_avg", avg);
  if (avg!=0)
   writeFeature("mst_degree_std", std/avg);
else
   writeFeature("mst_degree_std", 0);
    writeFeature("mst_degree_skew", skew);
    
    delete [] mst_degree;
	 
}

/////////////////////////////////////////////////////////////////////////////
void TSPinstance::display_mst()
{
	int i;
	cout << "\nThe Edges of the Mininum Spanning Tree are\n\n";
	for (i = 0; i < spec->dimension-1; i++)
		cout << mst_tree[i][0] << " " << mst_tree[i][1] << endl;
	cout << "\nThe Total cost of the Minimum Spanning Tree is : " << mst_cost <<endl;
}

/////////////////////////////////////////////////////////////////////////////
void TSPinstance::cluster_distance()
{
     priority_queue<edge, deque<edge>, greater<edge> > tree;
     int a,b;
     for ( int i=0; i< spec->dimension-1; i++) {
         a = mst_tree[i][0];
         b = mst_tree[i][1];
  
       double distfoo= comp_dist(a,b);
       tree.push(edge(a, b, distfoo));
     }
            
      mysets=new set<int> [spec->dimension]; 
      for (int i=0;i<spec->dimension; i++){
          mysets[i].insert(i);
      }
      int sumA, sumB;
         
     while (tree.size()>0) {
          const edge& e = tree.top();
          sumA=mysets[e.a].size();
          sumB=mysets[e.b].size();
                //    cout << sumA << "   "<<sumB<< " " << e.length<<endl;
           for (set<int>::iterator it=mysets[e.b].begin(); it!=mysets[e.b].end(); it++ ){
               mysets[e.a].insert(*it);
               // cout << "it1 has value  " << *it <<endl;
               }
           for (set<int>::iterator it=mysets[e.a].begin(); it!=mysets[e.a].end(); it++ ){
               mysets[*it]=mysets[e.a];
               // cout << "it2 has value  " << *it <<endl;
           }
    //       pair<double, double> anode(1,2);
   //        mst_cd.push_back(anode);
           mst_cd.push_back(pair<double, double>(e.length, sumA*sumB));
        //   cout << "here we are!" <<endl;
           tree.pop();
         }
    //   cout << "to the end !!!  " <<endl;
    double tmpcd=0;
    double tmpSum=0;
    double tmpPowSum=0;
    double tmpPow3Sum=0;
    double tmpCount=0;
    double totalCount=0;
    
    for (int i=0; i< spec->dimension-1; i++){     
          tmpcd=mst_cd.at(i).first;
          tmpCount=mst_cd.at(i).second;
          totalCount=totalCount+tmpCount;
  
         tmpPowSum= tmpPowSum+tmpcd*tmpcd*tmpCount;
         tmpSum=tmpSum+tmpcd*tmpCount;
         tmpPow3Sum=tmpPow3Sum +tmpcd*tmpcd*tmpcd*tmpCount;
    }
    
     cd_avg= tmpSum/totalCount;
     cd_std = sqrt((tmpPowSum-pow(tmpSum, 2)/totalCount)/totalCount);
     cd_skew = tmpPow3Sum - 3*tmpPowSum*cd_avg+3*tmpSum*pow(cd_avg, 2)-totalCount*pow(cd_avg,3);
if (cd_skew!=0)
     cd_skew= (totalCount*pow(cd_std,3))/cd_skew;
     
     writeFeature("cluster_distance_avg",cd_avg/cost_avg);
     writeFeature("cluster_distance_std",cd_std/cd_avg);
     writeFeature("cluster_distance_skew",cd_skew);
     
     //sd_skew = cost_skew/(totaledge*pow(cost_std,3));
     //sd_skew = sqrt(totaledge*(totaledge-1))*cost_skew/(totaledge-2);
    
}
          
 /////////////////////////////////////////////////////////////////////////////    
 void TSPinstance::ls_prob(const char* mypath)   
 { 
      int returnVal;
      tourfile=new char[256];
      finalfile=new char[256];
      strseed = new char[64];     
      sprintf(tourfile, "%s", P_tmpdir);
      strcat(tourfile, "/outputXXXXXX");
      mkstemp(tourfile);
      remove(tourfile);
      sprintf(finalfile, "%s.final", tourfile);
      sprintf(tourfile, "%s.tour", tourfile);
      double avg=0, std=0, skew=0;
    // cout << "tour file is"<< tourfile <<endl;
      
    for (int i=0; i<NRUNS; i++){
      gSW.Start();
      seed=(long)time(NULL);
      sprintf(strseed, "%ld", seed);
      BuildLS(tourfile, finalfile, strseed);
      returnVal = LSsolver -> execute(filename, -1, mypath);
//      printf("c %s returned code %d.\n", LSsolver->name, returnVal);
       
      fstream fin;
      fin.open(LSsolver->outFileName);
      if(fin.is_open()){
      //  printf("c Linkern runtime =%lf\n", gSW.TotalLap());
      }
     ls_outFileProcess(LSsolver->outFileName);
     ls_tourFileProcess(tourfile);
  }
    
 
  ///////////////////compute mean,  std, skewness of tour cons. heu./////////
   comp_ass(NRUNS, tch_cost, (cost_avg*spec->dimension), avg, std, skew );
   writeFeature("tour_const_heu_avg", avg);
   writeFeature("tour_const_std", std/avg);
   writeFeature("tour_const_skew", skew);
 
   ///////////////////compute mean,  std, skewness of steps to local mean, average improvement/////////
   comp_ass(NRUNS, lp_avg_imp_per_step, cost_avg, avg, std, skew );
   writeFeature("ls_impov_per_step_avg", avg);
   writeFeature("ls_impov_per_step_std", std);
   writeFeature("ls_impov_per_step_skew", skew);
 
   comp_ass(NRUNS, lp_steps2lm, spec->dimension, avg, std, skew );
   writeFeature("ls_steps_2lm_avg", avg);
   writeFeature("ls_steps_2lm_std", std);
   writeFeature("ls_steps_2lm_skew", skew);
   
  ///////////////////compute mean,  std, skewness of maxinum distance/////////
   comp_ass(NRUNS, max_dist, 1, avg, std, skew );
      
   writeFeature("ls_maxdist_avg", avg);
   writeFeature("ls_maxdist_std", std);
   writeFeature("ls_maxdist_skew", skew);
   
   ///////////////////compute mean,  std, skewness of local minima length/////////
   comp_ass(NRUNS, lp_bestsol, cost_avg, avg, std, skew );
      
   writeFeature("ls_bestsol_avg", avg);
   writeFeature("ls_bestsol_std", std);
   writeFeature("ls_bestsol_skew", skew);
    //////////////////////////////////////////////////////////// 
     ls_finalFileProcess(finalfile);
     comp_ass(lpedgefreq.size(), lpedgefreq, 1, avg, std, skew );
      
   writeFeature("ls_backbone_avg", avg);
   writeFeature("ls_backbone_std", std);
   writeFeature("ls_backbone_skew", skew);
 }
     
  /////////////////////////////////////////////////////////////////////////////   
void TSPinstance::ls_tourFileProcess(char* tourFile)
{ 
   ifstream fin;
   string mystring;
   fin.open(tourFile);
   int nOutput=0;
   int startread=0;
   int myfirst;
   int mysecond;
   int foo;
   int thesame=0;
   int minsame=spec->dimension;
   pair<int, int> onepair;
   multiset<pair<int, int> > statset; 
   
   while (! fin.eof() ){
         getline(fin, mystring);
          
         string strfoo="c";
         int pos1=mystring.find(strfoo);
        // cout << pos1 <<endl;
         if (pos1>-1){
          nOutput++;
          startread=0;
          if (nOutput>2){
             //   cout<< "the number of edge is the same as the first one" << thesame <<endl;
             if (thesame<minsame){
 //                cout<< "The number of edge is the same as the first one " << thesame << " " <<nOutput <<endl;
                 minsame=thesame;}
             }
          thesame=0;
         }
         else if(nOutput==1){
          istringstream in(mystring);
          while (in >> foo){
                if (startread==0){
                 myfirst=foo;
                 in >> mysecond;
                 startread=1;
                 }
                else{
                 myfirst=mysecond;
                 mysecond=foo;
                 }
           //     cout << myfirst << "---->"<<mysecond<< endl;
                if (myfirst<mysecond)
                 onepair= pair<int, int>(myfirst, mysecond);
                else
                  onepair=pair <int, int>(mysecond, myfirst);
                statset.insert(onepair);            
              }
       //      cout << "the number of edges is " << statset.size() << endl; 
           }
          else{
                istringstream in(mystring);
               if (!mystring.empty()){
                while (in >> foo){
                      if (startread==0){
                         myfirst=foo;
                         in >> mysecond;
                         startread=1;
                         }
                      else{
                           myfirst=mysecond;
                           mysecond=foo;
                      }
        //        cout << myfirst << "---->"<<mysecond<< endl;
                       if (myfirst<mysecond)
                          onepair= pair<int, int>(myfirst, mysecond);
                       else
                           onepair= pair<int, int>(mysecond, myfirst);
              //  cout<<onepair.first<< "************"<< onepair.second<< endl;
                       if (statset.count(onepair)>0)
                          thesame++;
                   }
                   }
              }    
         }
   //      cout<< "The number of edge is the same as the first one " << thesame <<endl << endl;
         if (thesame<minsame)
              minsame=thesame;
         max_dist.push_back(double(spec->dimension-minsame)/double(spec->dimension));
         // in the end remove the file
   fin.close();
    if (remove(tourfile) !=0)
           cout<<"Remove operation failed"<<endl;
  // else
  //         cout<<tourfile<<" has been removed."<<endl;    
}     
 
 /////////////////////////////////////////////////////////////////////////////    
void TSPinstance::ls_outFileProcess(char* outFile)
{  
   /// we only care about steps and solution quality
   ifstream fin;
   fin.open(outFile);
   string mystring;
   int startread=0;
   int pos1;
   double myvalue;
   string newstr="";
   int countfoo=0;
   string tmp1, tmp2, tmp3, tmp4, tmp5, tmp6;
   vector <struct sts> oneOutPut;
   while (! fin.eof() ){
     if (startread==0){
       getline(fin, mystring);
       string targetstr="Starting Cycle:";
       pos1 = mystring.find (targetstr);
      
       if (pos1==0){
            startread=1;
            newstr=mystring.substr(pos1+targetstr.size());
             tch_cost.push_back(str_to_f(newstr));
         }
     }
     else{
        fin >> tmp1 >>tmp2 >>tmp3>>tmp4>>tmp5;
        getline(fin, tmp6);
        int foo=tmp2.find("Steps");
        
        if (foo>-1){
            countfoo++;
            struct sts onedata;
            onedata.step=str_to_i(tmp1)+1;
            onedata.time=str_to_f(tmp5);
            onedata.sol=str_to_f(tmp4);
            oneOutPut.push_back(onedata);           
            }
          }
      }    
      sts bestsol=oneOutPut.at(countfoo-1);
      sts firstsol=oneOutPut.at(0);
      sts foo;
    for (int i=0; i <countfoo; i++){
        foo=oneOutPut.at(i);
         if (foo.sol==bestsol.sol)
          break;
         }
    lp_avg_imp_per_step.push_back((firstsol.sol-foo.sol)/foo.step);
    lp_steps2lm.push_back(foo.step);
    lp_bestsol.push_back(bestsol.sol);
    fin.close();
    
    if (remove(outFile) !=0)
           cout<<"Remove operation failed"<<endl;
//     else
//           cout<<outFile<<" has been removed."<<endl;     
}

//////////////////////////////////////////////////////////////////
void TSPinstance::ls_finalFileProcess(char* finalFile)
{
   ifstream fin;
   string mystring;
   fin.open(finalFile);
   int nOutput=0;
   int myfirst;
   int mysecond; 
   int pos1=0;
   pair<int, int> onepair;
   multiset<pair<int, int> > mfinalset; 
   set<pair<int, int> > finalset; 
   
   while (! fin.eof() ){
          getline(fin, mystring);
          //fin.ignore();

          if (!mystring.empty()){
          string strfoo="c";
          pos1=mystring.find(strfoo);
          if (pos1>-1){
             nOutput++;
           }
          else {
               istringstream in(mystring);
               
              in >> myfirst;
               in >> mysecond;
                if (myfirst<mysecond)
                 onepair= pair<int, int>(myfirst, mysecond);
                else
                  onepair=pair <int, int>(mysecond, myfirst);
                 
                finalset.insert(onepair);
                mfinalset.insert(onepair);
                }            
              }
           }
           
         
   //      cout<<"c "<< mfinalset.size()<< " "<<finalset.size()<<endl;
              for (set<pair <int,int> >::iterator it=finalset.begin(); it!=finalset.end(); it++ ){ 
                   //lpedgefreq[itfoo]=double(mfinalset.count(*it))/double(nOutput);
                  lpedgefreq.push_back(double(mfinalset.count(*it))/double(nOutput));              
   //               cout << "done " <<double(mfinalset.count(*it))<<", "<<double(nOutput)<<endl;
                 }
         
         // in the end remove the file
         fin.close();
       if (remove(finalFile) !=0)
          cout<<"Remove operation failed"<<endl;
//         else
//           cout<<finalFile<<" has been removed."<<endl;

 }
 
 ////////////////////////////////////////////////////////////////////////////    
 void TSPinstance::bc_prob(const char* mypath)   
 { 
      int returnVal;
      lptour=new char[256];
      strseed = new char[64];
      
      sprintf(lptour, "%s", P_tmpdir);
      strcat(lptour, "/outputXXXXXX");
    //  cout << "here are !"<< endl;
      mkstemp(lptour);
      remove(lptour);   
      sprintf(lptour, "%s.lptour", lptour);
//      cout << "tour file is"<< lptour <<endl;
      gSW.Start();
      seed=(long)time(NULL);
      sprintf(strseed, "%ld", seed);
      BuildBC(lptour, strseed);
      returnVal = BCsolver -> execute(filename, -1, mypath);
//      printf("c %s returned code %d.\n", BCsolver->name, returnVal);
//       cout << "out file is"<< BCsolver->outFileName <<endl;
   fstream fin;
   fin.open(BCsolver->outFileName);
   if(fin.is_open()){
 //   printf("c Linkern runtime =%lf\n", gSW.TotalLap());
     }
    bc_outFileProcess(BCsolver->outFileName);
    bc_tourFileProcess(lptour);
}

////////////////////////////////////////////////////////////////
void TSPinstance::bc_tourFileProcess(char* lptour)
{ 
   ifstream fin;
   string mystring;
   fin.open(lptour);
   int lp1_n=0;
   int lpn1_n=0;
   
   int fooi;
   double foof;
   vector <double> not_one;
   
   getline(fin, mystring);
   while (! fin.eof() ){
          getline(fin, mystring);
          if (!mystring.empty()){
          istringstream in(mystring);
          in >> fooi >> fooi >> foof;
           if (foof>0.9999999999){
              lp1_n++;
              }
          else{
              not_one.push_back(foof);
              lpn1_n++;        
          } 
          }
   }
   vector <double> myvect;
  if (not_one.size()>0){
   myvect=comp_q(not_one);
   writeFeature("bc_no1s_min", myvect.at(0));
   writeFeature("bc_no1s_q25", myvect.at(1));
   writeFeature("bc_no1s_q50", myvect.at(2));
   writeFeature("bc_no1s_q75", myvect.at(3));
   writeFeature("bc_no1s_max", myvect.at(4));
 }
else {
 writeFeature("bc_no1s_min", 0);
   writeFeature("bc_no1s_q25", 0);
   writeFeature("bc_no1s_q50", 0);
   writeFeature("bc_no1s_q75", 0);
   writeFeature("bc_no1s_max", 0);
}
   
   double lp1_p=double(lp1_n)/double(spec->dimension);
   double lpn1_p=double(lpn1_n)/double(spec->dimension);
   
   writeFeature("bc_p1s", lp1_p);
   writeFeature("bc_pn1s", lpn1_p);                      
         // in the end remove the file
    fin.close();
   if (remove(lptour) !=0)
          cout<<"Remove operation failed"<<endl;
}     
 
 
/////////////////////////////////////////////////////////////////////
 /////////////////////////////////////////////////////////////////////////////    
void TSPinstance::bc_outFileProcess(char* outFile)
{  
   
   ifstream fin;
   fin.open(outFile);
   string mystring;
   string fooi;
   int pos1=0;
   double upperbond=99999999;
   double lowerbound=0;
   vector <struct sts> bc_cuts;
   int counter=0;
   double tmpbound, tmptime;
   struct sts onedata;
   vector <double> improve_bound;
   double cut_imrovement=0;
   double cut_imrovement_p=0;
   double improve_pre_step=0.0;
  
   while (! fin.eof() ){
        getline(fin, mystring);
        if (!mystring.empty()){
            string targetstr="Set initial upperbound";
            pos1 = mystring.find (targetstr);
      //      cout <<"c "<< mystring << endl;
            if (pos1==0){
              istringstream in(mystring);
              in >> fooi >> fooi >> fooi >> fooi>> upperbond;      
            }
            targetstr="LP Value";
            pos1 = mystring.find (targetstr);
            if (pos1>-1){
              istringstream in(mystring);
              in >> fooi >> fooi >> fooi>> tmpbound >> fooi;
              counter=counter+1;
              
              int ssize=fooi.size();
              fooi=fooi.substr(1, ssize-1);
              tmptime=str_to_f(fooi);
              onedata.step=counter;
              onedata.time=tmptime;
              cut_imrovement =(upperbond-tmpbound)/upperbond;
              onedata.sol=cut_imrovement;
              
             
              if (counter <2) {
              improve_pre_step=cut_imrovement-cut_imrovement_p;        
              }
                          else{
              improve_pre_step=cut_imrovement_p-cut_imrovement;
              }
              cut_imrovement_p=cut_imrovement;
              improve_bound.push_back(improve_pre_step);
    //          cout << "improvement for this cut is: " <<improve_pre_step<< endl;
              bc_cuts.push_back(onedata);        
           }
           targetstr="New lower bound";
           pos1 = mystring.find (targetstr);
            if (pos1==0){
              istringstream in(mystring);
              in >> fooi >> fooi >> fooi>> lowerbound;
           }
        }
   }
   
   double avg, std, skew;
   comp_ass(counter, improve_bound, 1, avg, std, skew );
// cout << counter<< "! \n";     
   writeFeature("bc_improv_per_cut_avg", avg);
if (avg!=0)
   writeFeature("bc_improv_per_cut_std", std/avg);
else
   writeFeature("bc_improv_per_cut_std", 0);
   writeFeature("bc_improv_per_cut_skew", skew);
   
   writeFeature("bc_upper_lower_ratio", (upperbond-lowerbound)/upperbond);
    fin.close();
    
    if (remove(outFile) !=0)
           cout<<"Remove operation failed"<<endl;
}
 
///////////////////////////////////////////////////////////////////////////
/// write features  
void TSPinstance::writeFeature(const char *name, double val) {
  string s=string(string(name)); //featurePrefix)+ string(name);
 // nameToIndex[s] = indexCount;
  featureNames[indexCount] = strdup(s.c_str());
  featureVals[indexCount] = val;
  indexCount++;
  if(indexCount>=100){
      fprintf(stderr, "c TOO MANY FEATURES COMPUTED!\n");
      exit(1);
    }
  // printf("feature %d: %s; val: %f\n", indexCount, name, val);
}

void TSPinstance::writeFeaturesToFile(const char* name) {
  FILE *f = fopen(name, "a");
  if(f==NULL)
    writeFeaturesToFile(stderr);
  else{
      writeFeaturesToFile(f);
      fclose(f);
    }
}

void TSPinstance::writeFeaturesToFile(FILE* f) {
  if(f==NULL)
    f=stderr;
  for(int i = 0;i < indexCount - 1;i++) {
    fprintf(f, "%.9lf,", featureVals[i]);
  }
  fprintf(f, "%.9lf\n", featureVals[indexCount - 1]);
}

void TSPinstance::writeFeatNamesToFile(const char *name) {
  FILE *f = fopen(name, "a");
  if(f==NULL)
    writeFeatNamesToFile(stderr);
  else{
      writeFeatNamesToFile(f);
      fclose(f);
    }
}

void TSPinstance::writeFeatNamesToFile(FILE *f) {
  if(f==NULL)
    f=stderr;
    
  for(int i = 0;i < indexCount - 1;i++) {
    fprintf(f, "%s,", featureNames[i]);
  }
  fprintf(f, "%s\n", featureNames[indexCount - 1]);
}
 
void TSPinstance::comp_acf() {
  //   cout <<"start computing ACC\n";
     vector<int>   vi;  
     double *cost;
     cost=new double [R_WALK+1];
     
     int pf1, ps1, pf2, ps2, sp, ep;
     for   (int i=0; i<spec->dimension;   i++)  
          vi.push_back(i);  
    random_shuffle(vi.begin(), vi.end()); 
   
    srand((unsigned)time(NULL));
        
    cost[0]=0.0;
     for   (int i=0; i<spec->dimension-1;   i++)  {
      //    cout<<vi.at(i)<< ", ";
          cost[0]=cost[0]+comp_dist(vi.at(i), vi.at(i+1));
          }
          cost[0]=cost[0]+comp_dist(vi.at(0), vi.at(spec->dimension-1));
      //    cout<< vi.at(spec->dimension-1)<<endl;
          
    int r1, r2;
    for (int i=0; i<R_WALK; i++){
        cost[i+1]=0.0;
       r1= rand()%spec->dimension;;
       r2= rand()%spec->dimension; 
       while (abs(r2-r1)<2||abs(r2-r1)==spec->dimension-1){
             
          r2= rand()%spec->dimension; 
          }
       if (r1>r2){
         int foo = r2;
         r2=r1;
         r1=foo;
         }
      // cout << "r1 and r2 is: "<< r1 << ", "<< r2 << endl;
       pf2=vi.at(r2-1);
       ps2=vi.at(r2); 
       ps1=vi.at(r1);
       if (r1>0){
         pf1=vi.at(r1-1); 
         sp=r1;
         ep=r2;
         }
         else {
               pf2=vi.at(spec->dimension-1); 
               pf1=vi.at(r2-1);
               ps1=vi.at(r2); 
               ps2=vi.at(0);
               sp=r2;
               ep=spec->dimension;
              }
            
       for (int j=0; j<(ep-sp)/2; j++){
           int foo;
           foo= vi.at(sp+j);
           vi.at(sp+j)=vi.at(ep-1-j);
           vi.at(ep-1-j)=foo;
        }
        
        cost[i+1]=cost[i]-comp_dist(pf1, ps1)-comp_dist(pf2, ps2)+comp_dist(pf1,pf2)+comp_dist(ps1,ps2);
    //     for   (int i=0; i<spec->dimension;   i++)  
    //      cout<<vi.at(i)<< ", ";
    //       cout<< endl;
       }
        
        
        double sum_cost=0;
        double qsum_cost=0;
        double addxy=0;
        double timesxy=0;
        for (int i=0; i<=R_WALK; i++){
            sum_cost=sum_cost+cost[i];
            qsum_cost=qsum_cost+cost[i]*cost[i];
            if (i>0){
            addxy=addxy+cost[i-1]+cost[i];
            timesxy=timesxy+cost[i-1]*cost[i];
                     }
            
        }
       double avgfoo=sum_cost/(R_WALK+1);
       double eacf1=((timesxy-addxy*avgfoo)/(R_WALK)+avgfoo*avgfoo)/(qsum_cost/(R_WALK+1)-avgfoo*avgfoo);
       double acc=1/(1-eacf1);
       writeFeature("acc", acc);
       delete [] cost;
       
}
 
